package de.fraunhofer.iem.dataprovider.taskManager.tasks

import de.fraunhofer.iem.dataprovider.taskManager.model.Event
import de.fraunhofer.iem.dataprovider.toolRun.ToolRunService
import org.springframework.core.io.ClassPathResource
import org.springframework.core.io.Resource
import java.nio.file.Files
import java.nio.file.Path
import java.nio.file.Paths
import java.util.*


class DetektTask(
    projectPath: String, outputPath: String,
    override val responseChannel: suspend (task: Event) -> Unit,
    override val repoId: UUID,
    override val groupID: UUID? = null,
    override val toolRunService: ToolRunService
) : SarifTask() {

    private val resource: Resource = ClassPathResource("scripts/detekt.sh")
    override val flags: Array<String> = arrayOf(resource.file.absolutePath, projectPath, outputPath)
    override val execPath: String = "/bin/sh"
    override val resultPath: Path = Paths.get(outputPath, "detekt", "report.sarif")

    init {
        Files.createDirectories(Paths.get(outputPath, "detekt"))
    }
}
